
;******************************************************
.include "2313def.inc"
;******************************************************

;	.def Zeile 	= r00	;0...8
;	.def Spalte	= r01	;0...23
;	.def Adresse	= r02	;Bit 0...4 - Spaltenadresse
				;Bit 5...7 - Zeilenadresse
	.def Zahl	= r03	;ASCII-Zeichen
;	.def 	= r04
;	.def 	= r05
;	.def 	= r06
;	.def 	= r07
;	.def 	= r08
;	.def	= r09
;	.def	= r10
;	.def	= r11
Beginn:	.def Einer	= r12
	.def Zehner	= r13
	.def Hunderter	= r14
	.def Tausender	= r15
	.def TempA	= r16
	.def TempB	= r17
;	.def TempC	= r18
;	.def TempD 	= r19
;	.def TempE 	= r20
;	.def 	= r21
;	.def 	= r22
;	.def 	= r23
;	.def 	= r24
;	.def 	= r25
	.def HelpInt	= r26
	.def Zaehler1	= r27
;	.def Zaehler2	= r28
;	.def Zaehler3	= r29
;	.def RZlow	= r30	;Stringadresse low
;	.def RZhigh	= r31	;Stringadresse high

	.equ Teiler1 	= 0x01	;38400 Int./Sek. /  26 µSek.
	.equ Teiler8 	= 0x02	; 4800 Int./Sek. / 208 µSek.
	.equ Teiler64	= 0x03	;  600 Int./Sek. /1,67 mSek.
	.equ Teiler256	= 0x04	;  150 Int./Sek. /6,67 mSek
	.equ Teiler1024	= 0x05	; 37,5 Int./Sek. /26,7 mSek

	.equ RAMBegin	= 0x60	;Erste On-Chip SRAM-Adresse
	.equ RAMDigit	= 0x70	;Beginn der Digitadressen
;	.equ RAMEnd	= 0xDF	;Letzte On-Chip SRAM-Adresse

	.equ Enable	= 4	;Enable-Port
	.equ RW		= 5	;Schreib-Lese-Port
	.equ RS		= 6	;Daten-Steuer-Port
	.equ BF		= 3	;Bussy-Flag
	

.CSEG
.ORG 0000

;----------------------------------------------------------------------------

;	***  Interrupteinsprnge AT90S2313  ***

	rjmp	Reset		;Reset Handler
	reti			;Ext. IRQ0 Handler
	reti			;Ext. IRQ1 Handler
	reti			;Timer1 Capture Handler
	reti			;Timer1 compare Handler
	reti			;Timer1 Overflow Handler
	rjmp	Timer0		;Timer0 Overflow Handler
	reti			;UART RX Complete Handler
	reti			;UART Data Register Empty Handler
	reti			;UART TX Complete Handler
	reti			;Analog Comparator Handler

;----------------------------------------------------------------------------

;	***  Initialisierung  ***

Reset:	ldi	TempA,RAMEnd	
	out	SPL,TempA	;Stackpointer auf RAM-Ende

	clr	TempA		;Register loeschen
	out	PORTB,TempA	;Port B alles auf 0
	out	PORTD,TempA	;Port D alles auf 0
	out	DDRB,TempA	;Port B alles auf Input
	ser	TempA		;Register setzen
	out	DDRD,TempA	;Port D alles auf Output
	
	ldi	TempA,1<<TOIE0	;0000 0010  
	out	TIMSK,TempA	;Timer 0 Interrupt ein
	clr	TempA
	out	TCNT0,TempA	;Startwert des Timers = 0
	ldi	TempA,Teiler1024 
	out	TCCR0,TempA	;Timer starten mit Vorteiler 1024
	sei			;Interrupts generell aktivieren


;	---  Resetwarteschleife ca. 1 Sek.  ---
	rcall	Tim1S		;1 Sekumde warten, Power on
	rcall	InitDsp		;Display initialisieren
	rcall	Tim1S		;1 Sekumde warten, Power on
	rcall	Tim1S		;1 Sekumde warten, Power on

	
	
	rcall	GraOut
	
	
	
	ldi	TempA,0x4B
	mov	Adresse,TempA
	ldi	TempA,0x84
	mov	Zeichen,TempA
	rcall	ChrAdr
	inc	Zeichen
	rcall	ChrCur
	ldi	TempA,0xAB
	mov	Adresse,TempA
	ldi	TempA,0x84
	mov	Zeichen,TempA
	rcall	ChrAdr
	inc	Zeichen
	rcall	ChrCur


	
	ldi	TempA,9
	mov	Einer,TempA
	ldi	TempA,4
	mov	Zehner,TempA
	ldi	TempA,2
	mov	Hunderter,TempA
	ldi	TempA,1
	mov	Tausender,TempA


	rcall	ZaGes


Loop98:

	rjmp	Loop98

	rcall	Tim5S
	mov	Einer,Zehner
	mov	Zehner,Hunderter
	mov	Hunderter,Tausender
	inc	Tausender
	ldi	TempA,0x0B
	cp	Tausender,TempA
	brne	Loop98
	ldi	TempA,0
	mov	Tausender,TempA
	rjmp	Loop98




Loop99:	
	rjmp	Loop99		;dynamischer Halt





;----------------------------------------------------------------------------

;	***  Unterprogramme  ***



;	---  Timer 0 Interrupt  ---
;       nicht benutzt

Timer0:
	reti

	.def Ylo	= r28
	.def Yhi	= r29
	.def Zlo	= r30	;Stringadresse low
	.def Zhi	= r31	;Stringadresse high

ZaGes:	push	TempA
	push	TempB
	ldi	TempA,3
ZaG01:	ldi	Zhi,High(2*Adressen)
	ldi	Zlo,Low(2*Adressen)
	add	Zlo,TempA
	push	R0
	lpm
	mov	TempB,R0
	pop	R0
	mov	Adresse,TempB
;	ldi	Zhi,High(Beginn)
;	ldi	Zlo,Low(Beginn)
	ldi	Zhi,0x00
	ldi	Zlo,0x0C
	add	Zlo,TempA
	ld	Zahl,Z
	rcall	ZaAdr
	tst	TempA
	breq	ZaG02
	dec	TempA
	rjmp	ZaG01
ZaG02:	pop	TempB
	pop	TempA
	ret

ZaAdr:	push	TempA
	push	TempB
	ldi	Zhi,High(2*Ziffern)
	ldi	Zlo,Low(2*Ziffern)
	add	Zlo,Zahl
	add	Zlo,Zahl
	push	R0
	lpm
	mov	Ylo,R0
	inc	Zlo
	lpm
	mov	Yhi,R0
	pop	R0
	mov	Zlo,Ylo
	mov	Zhi,Yhi
	ldi	TempB,0xFA	;Zaehler mit 6 initialisieren
	ldi	TempA,0x20	;Zeilenerhoehungsfaktor
ZaA01:	rcall	StrAdr	
	add	Adresse,TempA
	inc	TempB
	brne	ZaA01
	pop	TempB
	pop	TempA
	ret

;	---  Fuellen des Grafikspeichers  ---

GraOut:	push	TempA
	push	TempB
	ldi	TempB,0xC0	;Beginn Grafikspeicher
	rcall	CursOut
	ldi	TempA,0xC0	;Zaehler setzen
	ldi	RZhigh,High(2*Grafik)
	ldi	RZlow,Low(2*Grafik)
	push	R0
Gra01:	lpm
	mov	TempB,R0
	rcall	ChrOut
	adiw	RZlow,1
	inc	TempA
	brne	Gra01
	pop	R0
	pop	TempB
	pop	TempB
	ret

;	---  Warteschleifen ohne Interrupt  ---

Tim10S:	push	Zaehler1	;10 Sekunden
	ldi	Zaehler1,100
	rjmp	Timer4
Tim5S:	push	Zaehler1	;5 Sekunden
	ldi	Zaehler1,50
	rjmp	Timer4
Tim2S:	push	Zaehler1	;2 Sekunden
	ldi	Zaehler1,20
	rjmp	Timer4
Tim1S:	push	Zaehler1	;1 Sekunde
	ldi	Zaehler1,10
	rjmp	Timer4
Tim500m:push	Zaehler1	;1 Sekunde
	ldi	Zaehler1,5
	rjmp	Timer4
Tim200m:push	Zaehler1	;1 Sekunde
	ldi	Zaehler1,2
Timer4:	rcall	Tim100m
	dec	Zaehler1
	or	Zaehler1,Zaehler1
	brne	Timer4
	pop	Zaehler1
	ret

Tim100m:push	Zaehler1	;100 Millisekunden
	ldi	Zaehler1,100
	rjmp	Timer3
Tim10m:	push	Zaehler1	;10 Millisekunden
	ldi	Zaehler1,10
Timer3:	rcall	Tim1m
	dec	Zaehler1
	or	Zaehler1,Zaehler1
	brne	Timer3
	pop	Zaehler1
	ret

Tim1m:	push	Zaehler1	;1 Millisekunde
	ldi	Zaehler1,100
	rjmp	Timer2
Tim100:	push	Zaehler1	;100 Mikrosekunden
	ldi	Zaehler1,10
Timer2:	rcall	Tim10
	dec	Zaehler1
	or	Zaehler1,Zaehler1
	brne	Timer2
	pop	Zaehler1
	ret

Tim10:	push	Zaehler1	;10 Mikrosekunden
	ldi	Zaehler1,20
	rjmp	Timer1
Tim1:	push	Zaehler1	;1 Mikrosekunde
	ldi	Zaehler1,2
Timer1:	dec	Zaehler1
	or	Zaehler1,Zaehler1
	brne	Timer1
	pop	Zaehler1
	ret



;******************************************************
.include "0282Adef.inc"
;******************************************************



	.org	0x0300

Ziffern:
	.dw	Null * 2
	.dw	Eins * 2
	.dw	Zwei * 2
	.dw	Drei * 2
	.dw	Vier * 2
	.dw	Fuenf * 2
	.dw	Sechs * 2
	.dw	Sieben * 2
	.dw	Acht * 2
	.dw	Neun * 2
	.dw	Leer * 2

Null:
	.db	0xF8, 0x9B, 0x9B, 0x9B, 0xF9, 0x00
	.db	0x9B, 0xFB, 0x20, 0xFA, 0x9B, 0x00
	.db	0x9B, 0x20, 0x20, 0x20, 0x9B, 0x00
	.db	0x9B, 0x20, 0x20, 0x20, 0x9B, 0x00
	.db	0x9B, 0xF9, 0x20, 0xF8, 0x9B, 0x00
	.db	0xFA, 0x9B, 0x9B, 0x9B, 0xFB, 0x00

Eins:
	.db	0x20, 0xF8, 0x9B, 0x20, 0x20, 0x00
	.db	0x20, 0xFB, 0x9B, 0x20, 0x20, 0x00
	.db	0x20, 0x20, 0x9B, 0x20, 0x20, 0x00
	.db	0x20, 0x20, 0x9B, 0x20, 0x20, 0x00
	.db	0x20, 0x20, 0x9B, 0x20, 0x20, 0x00
	.db	0x20, 0x9B, 0x9B, 0x9B, 0x20, 0x00

Zwei:
	.db	0xF8, 0x9B, 0x9B, 0x9B, 0xF9, 0x00
	.db	0x9B, 0xFB, 0x20, 0xFA, 0x9B, 0x00
	.db	0x20, 0x20, 0x20, 0xF8, 0xFB, 0x00
	.db	0x20, 0xF8, 0x9B, 0xFB, 0x20, 0x00
	.db	0xF8, 0xFB, 0x20, 0x20, 0x20, 0x00
	.db	0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x00

Drei:
	.db	0xF8, 0x9B, 0x9B, 0x9B, 0xF9, 0x00
	.db	0x9B, 0xFB, 0x20, 0xFA, 0x9B, 0x00
	.db	0x20, 0x20, 0x20, 0xF8, 0xFB, 0x00
	.db	0x20, 0x20, 0x20, 0xFA, 0xF9, 0x00
	.db	0x9B, 0xF9, 0x20, 0xF8, 0x9B, 0x00
	.db	0xFA, 0x9B, 0x9B, 0x9B, 0xFB, 0x00

Vier:
	.db	0x20, 0x20, 0x20, 0xF8, 0xFB, 0x00
	.db	0x20, 0x20, 0xF8, 0xFB, 0x20, 0x00
	.db	0x20, 0xF8, 0xFB, 0x9B, 0x20, 0x00
	.db	0xF8, 0xFB, 0x20, 0x9B, 0x20, 0x00
	.db	0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x00
	.db	0x20, 0x20, 0x20, 0x9B, 0x20, 0x00

Fuenf:
	.db	0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x00
	.db	0x9B, 0x20, 0x20, 0x20, 0x20, 0x00
	.db	0x9B, 0x9B, 0x9B, 0x9B, 0xF9, 0x00
	.db	0x20, 0x20, 0x20, 0xFA, 0x9B, 0x00
	.db	0x9B, 0xF9, 0x20, 0xF8, 0x9B, 0x00
	.db	0xFA, 0x9B, 0x9B, 0x9B, 0xFB, 0x00

Sechs:
	.db	0xF8, 0x9B, 0x9B, 0x9B, 0xF9, 0x00
	.db	0x9B, 0x20, 0x20, 0x20, 0x20, 0x00
	.db	0x9B, 0xF8, 0x9B, 0x9B, 0xF9, 0x00
	.db	0x9B, 0xFB, 0x20, 0xFA, 0x9B, 0x00
	.db	0x9B, 0xF9, 0x20, 0xF8, 0x9B, 0x00
	.db	0xFA, 0x9B, 0x9B, 0x9B, 0xFB, 0x00

Sieben:
	.db	0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x00
	.db	0x20, 0x20, 0x20, 0xF8, 0xFB, 0x00
	.db	0x20, 0x20, 0xF8, 0xFB, 0x20, 0x00
	.db	0x20, 0xF8, 0xFB, 0x20, 0x20, 0x00
	.db	0x20, 0x9B, 0x20, 0x20, 0x20, 0x00
	.db	0x20, 0x9B, 0x20, 0x20, 0x20, 0x00

Acht:
	.db	0xF8, 0x9B, 0x9B, 0x9B, 0xF9, 0x00
	.db	0x9B, 0xFB, 0x20, 0xFA, 0x9B, 0x00
	.db	0xFA, 0xF9, 0x87, 0xF8, 0xFB, 0x00
	.db	0xF8, 0xFB, 0x86, 0xFA, 0xF9, 0x00
	.db	0x9B, 0xF9, 0x20, 0xF8, 0x9B, 0x00
	.db	0xFA, 0x9B, 0x9B, 0x9B, 0xFB, 0x00

Neun:
	.db	0xF8, 0x9B, 0x9B, 0x9B, 0xF9, 0x00
	.db	0x9B, 0xFB, 0x20, 0xFA, 0x9B, 0x00
	.db	0x9B, 0xF9, 0x20, 0xF8, 0x9B, 0x00
	.db	0xFA, 0x9B, 0x9B, 0xFB, 0x9B, 0x00
	.db	0x20, 0x20, 0x20, 0x20, 0x9B, 0x00
	.db	0xFA, 0x9B, 0x9B, 0x9B, 0xFB, 0x00

Leer:
	.db	0x20, 0x20, 0x20, 0x20, 0x20, 0x00
	.db	0x20, 0x20, 0x20, 0x20, 0x20, 0x00
	.db	0x20, 0x20, 0x20, 0x20, 0x20, 0x00
	.db	0x20, 0x20, 0x20, 0x20, 0x20, 0x00
	.db	0x20, 0x20, 0x20, 0x20, 0x20, 0x00
	.db	0x20, 0x20, 0x20, 0x20, 0x20, 0x00

	.org	0x03D8
Grafik:
	.db	0x01, 0x01, 0x03, 0x03, 0x07, 0x07, 0x0F, 0x0F
	.db	0x10, 0x10, 0x18, 0x18, 0x1C, 0x1C, 0x1E, 0x1E

	.db	0x0F, 0x07, 0x07, 0x03, 0x03, 0x01, 0x01, 0x01
	.db	0x1E, 0x1C, 0x1C, 0x18, 0x18, 0x10, 0x10, 0x10

	.db	0x1F, 0x1E, 0x1C, 0x18, 0x18, 0x10, 0x10, 0x00
	.db	0x1F, 0x0F, 0x07, 0x03, 0x03, 0x01, 0x01, 0x00

	.db	0x10, 0x10, 0x18, 0x18, 0x1C, 0x1E, 0x1F, 0x1F
	.db	0x01, 0x01, 0x03, 0x03, 0x07, 0x0F, 0x1F, 0x1F


	.org	0x03FC
Adressen:
	.db	0x33, 0x2D, 0x26, 0x20
